
#include "stage.h"


SET_STAGEINFO(CStage)

//****************************************************************
//Xe[W̏
//****************************************************************
CStage::CStage(SDI_STAGEINFO2 *info) : CStageBase(info)
{
}

void CStage::InitializeStage()
{
	InitVrtx();//_W
	LoadTextures();//eNX`Ǎ
}

void CStage::InitVrtx()//_W
{
	int i, j;
	float x0, y0;
	BYTE alpha;
	MYVERTEX3D* vtx_tmp = NULL;
	LPDIRECT3DDEVICE9 d3ddev = GetD3DDevice();
	if (!d3ddev)return;

	vb_jinja = NULL;
	vb_stone = NULL;
	vb_ground = NULL;
	for (i = 0; i<NUM_TREES; i++)
		vb_tree[i] = NULL;
	vb_sky = NULL;

	//
	if (SUCCEEDED(d3ddev->CreateVertexBuffer(sizeof(MYVERTEX3D) * 4, 0, FVF_3DVERTEX, D3DPOOL_MANAGED, &vb_sky, NULL)) &&
		SUCCEEDED(vb_sky->Lock(0, 0, (void**)&vtx_tmp, 0)))
	{
		vtx_tmp[0].color = vtx_tmp[1].color =
			vtx_tmp[2].color = vtx_tmp[3].color = 0xFFFFFFFF;
		vtx_tmp[0].tu = 0;
		vtx_tmp[0].tv = 0;
		vtx_tmp[1].tu = 0;
		vtx_tmp[1].tv = 1;
		vtx_tmp[2].tu = 1;
		vtx_tmp[2].tv = 0;
		vtx_tmp[3].tu = 1;
		vtx_tmp[3].tv = 1;
		vtx_tmp[0].x = -12.0f;
		vtx_tmp[0].y = -18.0f;
		vtx_tmp[1].x = -12.0f;
		vtx_tmp[1].y = 0.0f;
		vtx_tmp[2].x = 12.0f;
		vtx_tmp[2].y = -18.0f;
		vtx_tmp[3].x = 12.0f;
		vtx_tmp[3].y = 0.0f;
		vtx_tmp[0].z = vtx_tmp[1].z =
			vtx_tmp[2].z = vtx_tmp[3].z = 20;

		vb_sky->Unlock();
	}

	//_
	if (SUCCEEDED(d3ddev->CreateVertexBuffer(sizeof(MYVERTEX3D) * 4, 0, FVF_3DVERTEX, D3DPOOL_MANAGED, &vb_jinja, NULL)) &&
		SUCCEEDED(vb_jinja->Lock(0, 0, (void**)&vtx_tmp, 0)))
	{
		vtx_tmp[0].color = vtx_tmp[1].color =
			vtx_tmp[2].color = vtx_tmp[3].color = 0xFFFFFFFF;
		vtx_tmp[0].tu = 0;
		vtx_tmp[0].tv = 0;
		vtx_tmp[1].tu = 0;
		vtx_tmp[1].tv = 1;
		vtx_tmp[2].tu = 1;
		vtx_tmp[2].tv = 0;
		vtx_tmp[3].tu = 1;
		vtx_tmp[3].tv = 1;
		vtx_tmp[0].x = -4.0f;
		vtx_tmp[0].y = -4.0f;
		vtx_tmp[1].x = -4.0f;
		vtx_tmp[1].y = 0.0f;
		vtx_tmp[2].x = 4.0f;
		vtx_tmp[2].y = -4.0f;
		vtx_tmp[3].x = 4.0f;
		vtx_tmp[3].y = 0.0f;
		vtx_tmp[0].z = vtx_tmp[1].z =
			vtx_tmp[2].z = vtx_tmp[3].z = 7;

		vb_jinja->Unlock();
	}

	//n
	if (SUCCEEDED(d3ddev->CreateVertexBuffer(sizeof(MYVERTEX3D) * 4, 0, FVF_3DVERTEX, D3DPOOL_MANAGED, &vb_ground, NULL)) &&
		SUCCEEDED(vb_ground->Lock(0, 0, (void**)&vtx_tmp, 0)))
	{
		vtx_tmp[0].color = vtx_tmp[1].color =
			vtx_tmp[2].color = vtx_tmp[3].color = 0xFFFFFFFF;
		vtx_tmp[0].tu = 0;
		vtx_tmp[0].tv = 0;
		vtx_tmp[1].tu = 0;
		vtx_tmp[1].tv = 1;
		vtx_tmp[2].tu = 1;
		vtx_tmp[2].tv = 0;
		vtx_tmp[3].tu = 1;
		vtx_tmp[3].tv = 1;
		vtx_tmp[0].x = -12.0f;
		vtx_tmp[0].y = 0.0f;
		vtx_tmp[1].x = -12.0f;
		vtx_tmp[1].y = 0.0f;
		vtx_tmp[2].x = 12.0f;
		vtx_tmp[2].y = 0.0f;
		vtx_tmp[3].x = 12.0f;
		vtx_tmp[3].y = 0.0f;
		vtx_tmp[0].z = 20;
		vtx_tmp[1].z = -1;
		vtx_tmp[2].z = 20;
		vtx_tmp[3].z = -1;

		vb_ground->Unlock();
	}

	//
	if (SUCCEEDED(d3ddev->CreateVertexBuffer(sizeof(MYVERTEX3D) * 4, 0, FVF_3DVERTEX, D3DPOOL_MANAGED, &vb_stone, NULL)) &&
		SUCCEEDED(vb_stone->Lock(0, 0, (void**)&vtx_tmp, 0)))
	{
		vtx_tmp[0].color = vtx_tmp[1].color =
			vtx_tmp[2].color = vtx_tmp[3].color = 0xFFFFFFFF;
		vtx_tmp[0].tu = 0;
		vtx_tmp[0].tv = 0;
		vtx_tmp[1].tu = 0;
		vtx_tmp[1].tv = 1;
		vtx_tmp[2].tu = 1;
		vtx_tmp[2].tv = 0;
		vtx_tmp[3].tu = 1;
		vtx_tmp[3].tv = 1;
		vtx_tmp[0].x = -0.9f;
		vtx_tmp[0].y = -0.45f;
		vtx_tmp[1].x = -0.9f;
		vtx_tmp[1].y = 0.0f;
		vtx_tmp[2].x = 0.9f;
		vtx_tmp[2].y = -0.45f;
		vtx_tmp[3].x = 0.9f;
		vtx_tmp[3].y = 0.0f;
		vtx_tmp[0].z = 5.5f;
		vtx_tmp[1].z = 4.5f;
		vtx_tmp[2].z = 5.5f;
		vtx_tmp[3].z = 4.5f;

		vb_stone->Unlock();
	}

	//
	for (i = 0; i < NUM_TREES; i++){
		if (SUCCEEDED(d3ddev->CreateVertexBuffer(sizeof(MYVERTEX3D)* ((NUM_TREES + 1) * 2), 0, FVF_3DVERTEX, D3DPOOL_MANAGED, &vb_tree[i], NULL)) &&
			SUCCEEDED(vb_tree[i]->Lock(0, 0, (void**)&vtx_tmp, 0)))
		{
			vtx_tmp[0].color =
				vtx_tmp[1].color =
				vtx_tmp[2].color =
				vtx_tmp[3].color = 0xFFFFFFFF;
			vtx_tmp[0].tv = 0;
			vtx_tmp[0].tu = 0;
			vtx_tmp[1].tv = 0;
			vtx_tmp[1].tu = 1;
			vtx_tmp[2].tv = 1;
			vtx_tmp[2].tu = 0;
			vtx_tmp[3].tv = 1;
			vtx_tmp[3].tu = 1;
			if (i % 2 == 0){
				vtx_tmp[0].x = vtx_tmp[2].x = -3.5f - i*0.2f;
				vtx_tmp[1].x = vtx_tmp[3].x = -2.5f;
			}
			else{
				vtx_tmp[0].x = vtx_tmp[2].x = -3.5f - i*0.2f*1.8;
				vtx_tmp[1].x = vtx_tmp[3].x = -2.5f - i*0.2f*0.8;
			}
			vtx_tmp[0].y = vtx_tmp[1].y = -1.8f - i*0.3f;
			vtx_tmp[2].y = vtx_tmp[3].y = 0.0f;
			vtx_tmp[0].z =
				vtx_tmp[1].z =
				vtx_tmp[2].z =
				vtx_tmp[3].z = 0.5f+i*1.4f;
			vb_tree[i]->Unlock();
		}
	}

}

void CStage::LoadTextures()//eNX`Ǎ
{
	LPDIRECT3DDEVICE9 d3ddev = GetD3DDevice();
	if(!d3ddev)return;

	ptex_jinja = NULL;
	ptex_stone = NULL;
	ptex_ground = NULL;
	ptex_tree = NULL;
	ptex_sky = NULL;

	char *filename=(char*)malloc(256);
	if(filename==NULL)return;

	//
	sprintf(filename,"%s\\.png",GetDLLPath());
	D3DXCreateTextureFromFileExA(
		d3ddev,filename,
		0,0,0,0,
		D3DFMT_A1R5G5B5,
		D3DPOOL_MANAGED,D3DX_FILTER_POINT,D3DX_FILTER_POINT,
		0xFF000000,NULL,NULL,
		&ptex_sky);
	
	//_
	sprintf(filename, "%s\\_.png", GetDLLPath());
	D3DXCreateTextureFromFileExA(
		d3ddev, filename,
		0, 0, 0, 0,
		D3DFMT_A1R5G5B5,
		D3DPOOL_MANAGED, D3DX_FILTER_POINT, D3DX_FILTER_POINT,
		0xFF000000, NULL, NULL,
		&ptex_jinja);

	//n
	sprintf(filename,"%s\\n.png",GetDLLPath());
	D3DXCreateTextureFromFileExA(
		d3ddev,filename,
		0,0,0,0,
		D3DFMT_X1R5G5B5,
		D3DPOOL_MANAGED,D3DX_FILTER_POINT,D3DX_FILTER_POINT,
		0,NULL,NULL,
		&ptex_ground);
	
	//
	sprintf(filename,"%s\\.png",GetDLLPath());
	D3DXCreateTextureFromFileA(
		d3ddev,
		filename,
		&ptex_stone);
	
	//
	sprintf(filename,"%s\\.png",GetDLLPath());
	D3DXCreateTextureFromFileA(
		d3ddev,
		filename,
		&ptex_tree);

	free(filename);
}

//****************************************************************
//Xe[Wn
//****************************************************************
CStage::~CStage()
{
	UnloadTextures();//eNX`J
}

void CStage::UnloadTextures()
{
	int i;

	RELEASE(ptex_jinja);
	RELEASE(ptex_stone);
	RELEASE(ptex_ground);
	RELEASE(ptex_tree);
	RELEASE(ptex_sky);

	RELEASE(vb_jinja);
	RELEASE(vb_stone);
	RELEASE(vb_ground);
	for (i = 0; i<NUM_TREES; i++)
		RELEASE(vb_tree[i]);
	RELEASE(vb_sky);
}

//****************************************************************
//bZ[W֐
//****************************************************************

void CStage::DrawStage()
{
	LPDIRECT3DDEVICE9 d3ddev = GetD3DDevice();
	if(!d3ddev)return;

	//eNX`AhbVO[h-JԂ
	d3ddev->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_WRAP);
	d3ddev->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_WRAP);
	d3ddev->SetFVF(FVF_3DVERTEX);

	d3ddev->Clear(0,NULL,D3DCLEAR_TARGET,D3DCOLOR_XRGB(5,0,20),1.0f,0);

	//`
	DrawBacks();

	//eNX`AhVO[h - ɖ߂
	d3ddev->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_CLAMP);
	d3ddev->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_CLAMP);
}

void CStage::DrawBacks()
{
	LPDIRECT3DDEVICE9 d3ddev = GetD3DDevice();
	if(!d3ddev)return;

	//Wϊ-Ȃ
	D3DXMATRIX mati;
	D3DXMatrixIdentity(&mati);
	d3ddev->SetTransform(D3DTS_WORLD,&mati);

	//_
	d3ddev->SetTexture(0, ptex_jinja);
	d3ddev->SetStreamSource(0, vb_jinja, 0, sizeof(MYVERTEX3D));
	d3ddev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	//
	d3ddev->SetTexture(0,ptex_stone);
	d3ddev->SetStreamSource(0, vb_stone, 0, sizeof(MYVERTEX3D));
	d3ddev->DrawPrimitive(D3DPT_TRIANGLESTRIP,0,2);
	//n
	d3ddev->SetTexture(0, ptex_ground);
	d3ddev->SetStreamSource(0, vb_ground, 0, sizeof(MYVERTEX3D));
	d3ddev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	//
	d3ddev->SetTexture(0, ptex_tree);
	for (int i = 0; i < NUM_TREES; i++){
		d3ddev->SetStreamSource(0, vb_tree[i], 0, sizeof(MYVERTEX3D));
		d3ddev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	}
	//
	d3ddev->SetTexture(0, ptex_sky);
	d3ddev->SetStreamSource(0, vb_sky, 0, sizeof(MYVERTEX3D));
	d3ddev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);

	//Α	
	D3DXMATRIX matrx;
	D3DXPLANE plane_x;
	plane_x.a = 1;
	plane_x.b = plane_x.c = plane_x.d = 0;
	D3DXMatrixReflect(&matrx, &plane_x);
	d3ddev->SetTransform(D3DTS_WORLD, &matrx);

	//
	d3ddev->SetTexture(0, ptex_tree);
	for (int i = 0; i < NUM_TREES; i++){
		d3ddev->SetStreamSource(0, vb_tree[i], 0, sizeof(MYVERTEX3D));
		d3ddev->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
	}
	
}
